<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\LancamentoCliConsumidorService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Util\Functions;

class LancamentoCliConsumidor  {
    protected $lancamentoService;
    protected $utilService;

    public function __construct (LancamentoCliConsumidorService $lancamentoService, Utilities\Util $utilService ){
        $this->utilService = $utilService;
        $this->lancamentoService = $lancamentoService;
    }
    
    public function getData(Request\Filter $request, Response $response) {
        $dataSourceName = 'vnd03730_lancamentoCliConsumidor';
        try{
            $conditions = $this->utilService->getParamsAsArray($request);
            
            if(empty($conditions['CDARVPRODI'])){
                unset($conditions['CDARVPRODI']);
                unset($conditions['CDARVPRODF']);
            }
            
            if(Functions::arrayKeyExists('DTPERIODO', $conditions)){
                if($conditions['DTPERIODO']){
                    if(!Functions::arrayKeyExists('CDFILIAL', $conditions)) {
                        $conditions['CDFILIAL'] = array();
                    }
                    if(!Functions::arrayKeyExists('CDLOJA', $conditions)) {
                        $conditions['CDLOJA'] = array();
                    }
                    if(!Functions::arrayKeyExists('CLIENTECONSUMIDOR', $conditions)) {
                        $conditions['CLIENTECONSUMIDOR'] = array();
                    }
                    if(!Functions::arrayKeyExists('CDCLIENTE', $conditions)) {
                        $conditions['CDCLIENTE'] = array();
                    }
                    if(!Functions::arrayKeyExists('CDARVPRODI', $conditions)) {
                        $conditions['CDARVPRODI'] = null;
                        $conditions['CDARVPRODF'] = null;
                    }
                    if(!Functions::arrayKeyExists('CDARVPRODF', $conditions)) {
                        $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
                    }
                    if(!Functions::arrayKeyExists('DTPERIODO', $conditions)) {
                        $conditions['DTPERIODO'] = null;
                    }
                    if(Functions::arrayKeyExists('DTPERIODO', $conditions)) {
                        $conditions['DTINI'] = $conditions['DTPERIODO'][0];
                        $conditions['DTFIM'] = $conditions['DTPERIODO'][1];
                        unset($conditions['DTPERIODO']);
                    }
                    $response->addDataSet(new DataSet($dataSourceName,
                    $this->lancamentoService->buscaDados($conditions['CDFILIAL'], $conditions['DTINI'], $conditions["DTFIM"], $conditions["CDARVPRODI"], $conditions["CDARVPRODF"], $conditions["CDLOJA"], $conditions["CDCLIENTE"], $conditions["NRORG"], $conditions['IDRELATORIO'], $conditions["CLIENTECONSUMIDOR"])));
                    return $response;
                }
            }
            else {
                return $response;
            }
        
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
  