<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Doctrine\ORM\EntityManager;

class ConversaoCodFilialService {
   
    protected $entityManager;
    
    public function __construct($entityManager) {
        $this->entityManager = $entityManager;
    }

	public function findCodigos ($nrorg) {
        try{
            $params = array(
                'NRORG' => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAll(Utilities\Query::FIND_CODIGOS_SAP, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }
    
    public function findOutrosCodigos ($nrorg, $letraRef) {
        try{
            $params = array(
                'NRORG' => $nrorg,
                'CDLETRACORR' => $letraRef
            );
            return $this->entityManager->getConnection()->fetchAll(Utilities\Query::FIND_OUTROS_CODIGOS_SAP, $params);
        }catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateCampos ($filialInicial, $filialFinal, $letra, $nrorg, $letraRef) {
        try{
            $params = array(
                'CDCODEXTINI' => $filialInicial,
                'CDCODEXTFIN' => $filialFinal,
                'NRORG'       => $nrorg,
                'CDLETRACORR' => $letra,
                'LETRAREF'    => $letraRef
                
            );
            return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_CAMPOS_SAP, $params);
        }catch(\Exception $e){
            throw $e;
        }  
    }
}