<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\NovoCodigo;

class ExportarLojaService {
	
	protected $novoCodigo;
	
	public function __construct(EntityManager $entityManager, NovoCodigo $novoCodigo) {
        $this->conn = $entityManager->getConnection();
        $this->novoCodigo  = $novoCodigo;
    }
    
	public function exportar($params) {
		
		$NRORG				= $params['NRORG'] . "";
		$CDFILIAIS			= $params['CDFILIAL'];
		$CDFILILOJAS 		= $params['CDLOJA'];
		$CDLOJAORIG 		= $params['CDLOJAORIG']; 
		$CDFILIALORIG		= $params['CDFILIALORIG']; 
		$NRCONFTELA 		= $params['NRCONFTELA'];
		$NMCONFTELA 		= $params['NMCONFTELA'];
		$DTINIVIGENCIA 		= $params['DTINIVIGENCIA'];
		$DTINIVIGENCIANEW 	= $params['DTINIVIGENCIANEW'];
		$EXPORTPOS      	= $params['EXPORTPOS'];
		
		try {
			foreach( $CDFILIAIS as $index => $CDFILIALDEST ) {
	     		$paramGetMax = array (
			     	":CDFILIAL" => $CDFILIALDEST,
			     	":NRORG"	=> $NRORG
			    );
			     	
	     		$maxNROCONFTELA = $this->conn->fetchAll(self::GET_MAX_NRCONFTELA, $paramGetMax);
	     		unset($paramGetMax);
	     		
	     		if(!empty($maxNROCONFTELA)) {
					$NRCONFTELADEST = str_pad($maxNROCONFTELA[0]['NRCONFTELA'], 5, "0", STR_PAD_LEFT);
	     		} else {
	     			$NRCONFTELADEST = "00000";
	     		}
	     		unset($maxNROCONFTELA);
	     		
				$CDLOJADEST = preg_replace( '/^' . $CDFILIALDEST . '{1}/', "", $CDFILILOJAS[$index]);

	     		$paramGetConfTela = array(
			     	":CDFILIAL" 	 => $CDFILIALORIG,
			     	":CDLOJA"		 => $CDLOJAORIG,
			     	":NRORG"		 => $NRORG,
			     	":DTINIVIGENCIA" => $DTINIVIGENCIA,
			     	":NRCONFTELA"	 => $NRCONFTELA
			    );
			    
				$CONFTELA = $this->conn->fetchAll(self::GET_DATA_CONFTELA, $paramGetConfTela);
	     		unset($paramGetConfTela);
				
				$paramsInsertConftela = array(
			     	":CDFILIAL" 	=> $CDFILIALDEST,
			     	":CDLOJA"		=> $CDLOJADEST,
			     	":NRCONFTELA"	=> $NRCONFTELADEST,
			     	":NMCONFTELA"	=> $NMCONFTELA,
			     	":DSFUNDOTELA"	=> $CONFTELA[0]['DSFUNDOTELA'],
			     	":DSLOGOTELA"	=> $CONFTELA[0]['DSLOGOTELA'],
			     	":IDESQUEMA"	=> $CONFTELA[0]['IDESQUEMA'],
			     	":DTINIVIGENCIA" => $DTINIVIGENCIANEW,
			     	":NRORG"		=> $NRORG
			    );
			    
			    try {
			    	$this->conn->executeQuery(self::INSERT_CONFTELA, $paramsInsertConftela);
					
					$params = array(
						'CDFILIALDEST'  	=> $CDFILIALDEST,
						'CDFILIALORIG'  	=> $CDFILIALORIG,
						'NRCONFTELADEST'	=> $NRCONFTELADEST,
						'NRCONFTELAORIG'	=> $NRCONFTELA,
						'DTINIVIGENCIA'	=> $DTINIVIGENCIA,
						'DTINIVIGENCIANEW'	=> $DTINIVIGENCIANEW
					);
					$this->saveProducts( $params );
					if ($EXPORTPOS == 'S'){
						$params = array(
							'CDFILIAL'      	=> $CDFILIALDEST,
							'NRCONFTELA'    	=> $NRCONFTELADEST,
							'CDFILIALORIG'  	=> $CDFILIALORIG,
							'NRCONFTELAORIG'	=> $NRCONFTELA,
							'DTINIVIGENCIA' 	=> $DTINIVIGENCIA,
							'DTINIVIGENCIANEW'	=> $DTINIVIGENCIANEW
						);
						$this->saveCaixas($params, ($DTINIVIGENCIANEW !== $DTINIVIGENCIA));
					}
					
					$params = array(
						'CDFILIAL'      	=> $CDFILIALDEST,
						'NRCONFTELA'    	=> $NRCONFTELADEST,
						'CDFILIALORIG'  	=> $CDFILIALORIG,
						'NRCONFTELAORIG'	=> $NRCONFTELA,
						'NRORG'		=> $NRORG
					);
					$this->saveSugestoes($params);
					
					
				} catch (\Exception $e) {
					throw $e;
				}
	     	}
		} catch (Exception $e) {
			throw $e;
		}
	}
	
	private function saveSugestoes( $params)
	{
		
		$CDFILIAL	= $params['CDFILIAL'];
		$NRCONFTELA	= $params['NRCONFTELA'];
		$CDFILIALORIG = $params['CDFILIALORIG'];
		$NRCONFTELAORIG	= $params['NRCONFTELAORIG'];
		$NRORG = $params['NRORG'];
		
		$paramsFindItMenu = array (
			"NRORG"	=> $NRORG,
	     	":NRCONFTELA"	=> $NRCONFTELAORIG,
	     	":CDFILIAL"		=> $CDFILIALORIG,
	     	
	    );
		
		$sugestoesitems = $this -> conn ->fetchAll(self::SELECT_SUGESTAOVENDA, $paramsFindItMenu);
		
		foreach($sugestoesitems as $suge) {
			$novoCodigoSugeVenda = $this->novoCodigo->getCodeByTableName('SUGESTAOVENDA', $NRORG,1,null,false);
			$paramsInsertItMenu = array(	
		     	":CDFILIAL" 		=> $CDFILIAL,
	     		":NRCONFTELA"		=> $NRCONFTELA,
	     		":NRORG"				=> $NRORG,
	     		":CDPRODUTO"			=> $suge['CDPRODUTO'],
	     		":IDSUGESTAOVENDA"		=> $novoCodigoSugeVenda
		    );
			$this->conn->executeQuery(self::INSERT_SUGESTAOVENDA, $paramsInsertItMenu);
			$paramsFindItProdutos = array(
				"NRORG" => $NRORG,
				"IDSUGESTAOVENDA" => $suge['IDSUGESTAOVENDA']
				
			);
			$sugestoesprodutos = $this -> conn ->fetchAll(self::SELECT_SUGESTAOITEM, $paramsFindItProdutos);
			
			foreach($sugestoesprodutos as $produ){
				$novoCodigoSugeProd = $this->novoCodigo->getCodeByTableName('SUGESTAOITEM', $NRORG,1,null,false);
				$paramsInsertItProdutos = array (
				":NRORG"				=> $NRORG,
				":IDSUGESTAOTIPO"		=> $produ['IDSUGESTAOTIPO'],
				":CDSUGESTAOITEM"		=> $produ['CDSUGESTAOITEM'],
				":NRORDEMSUG"			=> $produ['NRORDEMSUG'],
				":IDSUGESTAOITEM"			=> $novoCodigoSugeProd,
				":IDSUGESTAOVENDA"			=> $novoCodigoSugeVenda
				);
				$this ->conn -> executeQuery(self::INSERT_SUGESTAOITEM, $paramsInsertItProdutos);
			}
			
		}
	}
	
	private function saveCaixas( $params, $clearPOS ) {
		$CDFILIAL	= $params['CDFILIAL'];
		$NRCONFTELA	= $params['NRCONFTELA'];
		$CDFILIALORIG = $params['CDFILIALORIG'];
		$NRCONFTELAORIG	= $params['NRCONFTELAORIG'];
		$DTINIVIGENCIA	= $params['DTINIVIGENCIA'];
		$DTINIVIGENCIANEW	= $params['DTINIVIGENCIANEW'];
		
		
		$paramsFindItMenu = array (
	     	":CDFILIAL"		=> $CDFILIALORIG,
	     	":NRCONFTELA"		=> $NRCONFTELAORIG,
	     	":DTINIVIGENCIA"	=> $DTINIVIGENCIA
	    );
	
		$caixas = $this->conn->fetchAll(self::SELECT_CONFTELA_CAIXA, $paramsFindItMenu);
		
		foreach($caixas as $caixa) {
			$paramsInsertConftelaCaixa = array( 
	    		':CDFILIAL' 		=> $CDFILIAL,
	    		':NRCONFTELA'		=> $NRCONFTELA,
	    		':DTINIVIGENCIA'	=> $DTINIVIGENCIANEW,
	    		':CDFILICAIXA'  	=> $caixa['CDFILICAIXA'],
	    		':CDCAIXA'			=> $caixa['CDCAIXA'],
	    		':NRORG'			=> $caixa['NRORG']
			);
			
			if($clearPOS){
				$this->conn->executeQuery(self::INSERT_CONFTELACAIXA, $paramsInsertConftelaCaixa);
			}
		}
		
	}
	
	private function saveProducts( $params ) {
		$CDFILIALDEST	= $params['CDFILIALDEST'];
		$CDFILIALORIG	= $params['CDFILIALORIG'];
		$NRCONFTELADEST = $params['NRCONFTELADEST'];
		$NRCONFTELAORIG	= $params['NRCONFTELAORIG'];
		$DTINIVIGENCIA	= $params['DTINIVIGENCIA'];
		$DTINIVIGENCIANEW	= $params['DTINIVIGENCIANEW'];
		
		$paramsFindItMenu = array (
	     	":P_CDFILIAL"		=> $CDFILIALORIG,
	     	":P_NRCONFTELA"	=> $NRCONFTELAORIG,
	     	":DTINIVIGENCIA"	=> $DTINIVIGENCIA
	    );
	
		$products = $this->conn->fetchAll(self::SELECT_ITMENUCONFTE, $paramsFindItMenu);

		foreach($products as $prod) {
			$paramsInsertItMenu = array(	
		     	":CDFILIAL" 		=> $CDFILIALDEST,
	     		":NRCONFTELA"		=> $NRCONFTELADEST,
	     		":DTINIVIGENCIA"	=> $DTINIVIGENCIANEW,
		     	":IDTPBUTTON"		=> $prod['IDTPBUTTON'],
		     	":NRBUTTON" 		=> $prod['NRBUTTON'],
		     	":NRPGCONFTELA" 	=> $prod['NRPGCONFTELA'],
		     	":IDTPBUTONAUX" 	=> $prod['IDTPBUTONAUX'],
		     	":NRBUTTONAUX"		=> $prod['NRBUTTONAUX'],
    			":NRPGCONFTAUX" 	=> $prod['NRPGCONFTAUX'],
    			":CDIDENTBUTON" 	=> $prod['CDIDENTBUTON'],
    			":DSBUTTON" 		=> $prod['DSBUTTON'],
    			":NRCOLORTEXT"		=> $prod['NRCOLORTEXT'],
    			":IDEXIBEAPPCONS"	=> $prod['IDEXIBEAPPCONS'],
    			":NRCOLORBACK"		=> $prod['NRCOLORBACK'],
		        ":DSMESSAGEBUT" 	=> $prod['DSMESSAGEBUT'],
		        ":DSIMAGEMBUT"		=> $prod['DSIMAGEMBUT'],
		        ":NRFONTETEXT"		=> $prod['NRFONTETEXT'],
		        ":IDTPBUTONAUX2"	=> $prod['IDTPBUTONAUX2'],
		        ":NRBUTTONAUX2" 	=> $prod['NRBUTTONAUX2'],
		        ":NRPGCONFTAUX2"	=> $prod['NRPGCONFTAUX2'],
		        ':DSENDEIMG'		=> $prod['DSENDEIMG']
		    );
		   
			$this->conn->executeQuery(self::INSERT_ITMENUCONFTE, $paramsInsertItMenu);
		}
	}
	
    const GET_MAX_NRCONFTELA = "
		SELECT (M.NRCONFTELA + 1) AS NRCONFTELA, C.NMCONFTELA
		  FROM (SELECT MAX(NRCONFTELA) AS NRCONFTELA
		   		  FROM   CONFTELA
		   		 WHERE  CDFILIAL = :CDFILIAL) M, CONFTELA C
		 WHERE (C.CDFILIAL   = :CDFILIAL ) 
		   AND (C.NRORG   = :NRORG ) 
		   AND (M.NRCONFTELA = C.NRCONFTELA)
    ";
    
    const GET_DATA_CONFTELA = "    
		SELECT CDFILIAL, CDLOJA, NRCONFTELA, NMCONFTELA, DSFUNDOTELA, IDESQUEMA, DSLOGOTELA
    	  FROM CONFTELA
         WHERE (CDFILIAL   = :CDFILIAL) 
           AND (NRCONFTELA   = :NRCONFTELA) 
           AND (NRORG   = :NRORG) 
           AND (CDLOJA     = :CDLOJA  ) 
           AND (DTINIVIGENCIA     = :DTINIVIGENCIA  ) 
      ORDER BY NRCONFTELA, NMCONFTELA
    ";
    
	const INSERT_CONFTELA = "
		INSERT INTO CONFTELA (CDFILIAL, CDLOJA, NRCONFTELA, NMCONFTELA, DSFUNDOTELA , DSLOGOTELA, IDESQUEMA, NRORG, DTINIVIGENCIA)
        VALUES (:CDFILIAL, :CDLOJA, :NRCONFTELA, :NMCONFTELA, :DSFUNDOTELA, :DSLOGOTELA, :IDESQUEMA, :NRORG, :DTINIVIGENCIA)
    ";  
    
    
	const SELECT_ITMENUCONFTE = "
        SELECT CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
        	   NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, DSMESSAGEBUT, DSIMAGEMBUT, 
        	   NRFONTETEXT, IDTPBUTONAUX2, NRBUTTONAUX2, NRPGCONFTAUX2, DSENDEIMG, DTINIVIGENCIA, IDEXIBEAPPCONS
          FROM ITMENUCONFTE
         WHERE (CDFILIAL = :P_CDFILIAL)
           AND (NRCONFTELA = :P_NRCONFTELA)
           AND (DTINIVIGENCIA = :DTINIVIGENCIA)
           AND (IDTPBUTTON NOT IN ('3','4'))
	";
	
	const INSERT_ITMENUCONFTE = "
        INSERT INTO ITMENUCONFTE ( CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
								   NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, DSMESSAGEBUT, DSIMAGEMBUT, 
								   NRFONTETEXT, IDTPBUTONAUX2, NRBUTTONAUX2, NRPGCONFTAUX2, DSENDEIMG, DTINIVIGENCIA, IDEXIBEAPPCONS)
        VALUES (:CDFILIAL, :NRCONFTELA, :IDTPBUTTON, :NRBUTTON, :NRPGCONFTELA, :IDTPBUTONAUX, :NRBUTTONAUX,
        		:NRPGCONFTAUX, :CDIDENTBUTON, :DSBUTTON, :NRCOLORTEXT, :NRCOLORBACK, :DSMESSAGEBUT, :DSIMAGEMBUT, 
        		:NRFONTETEXT, :IDTPBUTONAUX2, :NRBUTTONAUX2, :NRPGCONFTAUX2, :DSENDEIMG, :DTINIVIGENCIA, :IDEXIBEAPPCONS)
    ";
    
    const SELECT_CONFTELA_CAIXA = "
    	SELECT CDFILICAIXA, CDCAIXA, NRORG
    	  FROM CONFTELACAIXA
    	  WHERE CDFILIAL = :CDFILIAL
    	    AND NRCONFTELA = :NRCONFTELA
    	    AND DTINIVIGENCIA = :DTINIVIGENCIA
    	  ORDER BY CDFILICAIXA, CDCAIXA
    ";
    
    const INSERT_CONFTELACAIXA = "
    	INSERT INTO CONFTELACAIXA ( CDFILIAL, NRCONFTELA, DTINIVIGENCIA, CDFILICAIXA, CDCAIXA, NRORG )
    	VALUES ( :CDFILIAL, :NRCONFTELA, :DTINIVIGENCIA, :CDFILICAIXA, :CDCAIXA, :NRORG )
    ";
    
    const INSERT_SUGESTAOVENDA = "
	INSERT INTO SUGESTAOVENDA
         (IDSUGESTAOVENDA, CDPRODUTO, NRCONFTELA, CDFILIAL, NRORG)
      VALUES
         (:IDSUGESTAOVENDA, :CDPRODUTO, :NRCONFTELA, :CDFILIAL, :NRORG)
    ";
    
    const SELECT_SUGESTAOVENDA = "
    	SELECT CDFILIAL, NRCONFTELA, IDSUGESTAOVENDA, CDPRODUTO
				FROM SUGESTAOVENDA
    				WHERE CDFILIAL = :CDFILIAL AND NRCONFTELA = :NRCONFTELA AND NRORG = :NRORG
    ";
    
    const SELECT_SUGESTAOITEM = "
	   SELECT IDSUGESTAOTIPO, CDSUGESTAOITEM, NRORDEMSUG
			FROM SUGESTAOITEM
    			WHERE IDSUGESTAOVENDA = :IDSUGESTAOVENDA AND NRORG = :NRORG
    ";
    const INSERT_SUGESTAOITEM = "
	INSERT INTO SUGESTAOITEM
         (IDSUGESTAOITEM, IDSUGESTAOVENDA, IDSUGESTAOTIPO, CDSUGESTAOITEM, NRORG, NRORDEMSUG)
      VALUES
         (:IDSUGESTAOITEM, :IDSUGESTAOVENDA, :IDSUGESTAOTIPO, :CDSUGESTAOITEM, :NRORG, :NRORDEMSUG)
    ";
}
